<?php

namespace IMATHUZH\Qfq\Core\Form\FormElement;

use IMATHUZH\Qfq\Core\Form\Form;
use IMATHUZH\Qfq\Core\Helper\HelperFormElement;
use IMATHUZH\Qfq\Core\Helper\Support;

class SelectFormElement extends AbstractFormElement
{
    public array $itemKeys = array();
    public array $itemValues = array();

    public function __construct($attributes, ?Form $form = null)
    {
        parent::__construct($attributes, $form);

        $this->setKeysAndValues();
        $this->setDefaults();
    }

    /**
     * Fills $this->itemKeys and $this->itemValues
     */
    private function setKeysAndValues(){
        HelperFormElement::getKeyValueListFromSqlEnumSpec($this->attributes, $this->itemKeys, $this->itemValues);
    }

    private function setDefaults(){
        $this->htmlAttributes['title'] = $this->attributes[FE_TOOLTIP];
        if(isset($this->attributes[FE_AUTOFOCUS])) $this->htmlAttributes[FE_AUTOFOCUS] = $this->attributes[FE_AUTOFOCUS];
        if(isset($this->attributes[F_FE_DATA_PATTERN_ERROR])) $this->htmlAttributes[F_FE_DATA_PATTERN_ERROR] = $this->attributes[F_FE_DATA_PATTERN_ERROR];
        if(isset($this->attributes[F_FE_DATA_REQUIRED_ERROR])) $this->htmlAttributes[F_FE_DATA_REQUIRED_ERROR] = $this->attributes[F_FE_DATA_REQUIRED_ERROR];
        $this->htmlAttributes[FE_DATA_LOAD] = $this->attributes[FE_DYNAMIC_UPDATE] === 'yes' ? 'data-load' : '';
        $this->htmlAttributes[ATTRIBUTE_DATA_REFERENCE] = $this->attributes[FE_DATA_REFERENCE];

        if (isset($this->attributes[FE_SIZE]) && $this->attributes[FE_SIZE] > 1) {
            $this->htmlAttributes[FE_SIZE] = $this->attributes[FE_SIZE];
            $this->htmlAttributes['multiple'] = 'multiple';
        }
    }
}